#!/usr/bin/python

######## EMI_ELEMENTS_4_BOX_CREATION ########
#              FLB STUDIO 2K4 (c) 2003-2004 #
#############################################
#                 TRANSPORT CONTROL BUTTONS #
#############################################

from Tkinter import *
from COLOR_FADER import *
class CTRL_BUTTON(Canvas):
	def __init__(self,master=None,rgb=[90,90,255],command=None,txt="",ctrls="PLAY",spring=0,comx2=0):
		self.spring=spring
		self.ctrls = None
		self.ctrlsId = None
		self.strcom = ["START","REW","PLAY","REC","STOP","PAUSE","FF","END"]
		for i in range(len(self.strcom)):
			if ctrls == self.strcom[i]:
				self.ctrls = ctrls
				self.ctrlsId = i
		if self.ctrls == None:
			self.ctrls = "PLAY"
			self.ctrlsId = 2
		self.master = master
		self.hy = 30
		self.wx = 30
		self.rgb = rgb
		self.space = 5
		self.comx2=comx2
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.colorTable=RGB2RGB(self.rgb,[39,39,39],self.space)
		self.v = 0.0
		self.ledstr =""
		self.push = 0
		self.divider = int(self.hy/self.space/2)
		self.txt=txt
		self.command=command
		self.bc = [69,69,69]
		self.bt = [0]*2
		self.polyOn = [(10,10, 12,10, 12,14, 20,10, 20,20, 12,16, 12,21, 10,21),(10,16, 15,12, 20,10, 20,12, 16,16, 20,20, 20,21, 19,21, 14,16, 18,12, 16,12, 12,16, 16,20, 16,21,15,21),(13,10, 20,15, 13,20),(15,10, 20,15, 15,20, 11,15),(12,12, 18,12, 18,18, 12,18),(10,21, 10,10, 12,10, 12,21, 19,21, 19,10, 21,10, 21,21),(20,15, 15,19, 10,21, 10,19, 14,15, 10,11, 10,10, 11,10, 16,15, 12,19, 14,19, 18,15, 14,11, 14,10, 15,10),(20,20, 18,20, 18,16, 10,20, 10,10, 18,14, 18,10, 20,10)]
		self.polyOff = [(9,9, 11,9, 11,14, 21,9, 21,21, 11,16, 11,22, 9,22),(10,16, 15,10, 20,10, 20,10, 16,16, 20,20, 20,21, 19,21, 14,16, 18,11, 16,11, 12,16, 16,20, 16,21,15,21),(11,8, 22,15, 11,22),(15,8, 22,15, 15,22, 9,15),(10,10, 20,10, 20,20, 10,20),(10,21, 10,10, 12,10, 12,21, 19,21, 19,10, 21,10, 21,21),(20,15, 15,21, 10,21, 10,21, 14,15, 10,11, 10,10, 11,10, 16,15, 12,20, 14,20, 18,15, 14,11, 14,10, 15,10),(21,21, 19,21, 19,16, 9,21, 9,9, 19,14, 19,9, 21,9)]
		self.colorOn = ["#96FFBB","#96FFBB","#96FFBB","#FF0000","#96FFBB","#DDFF00","#96FFBB","#96FFBB"]
		self.colorOff = ["#96BBAA","#96BBAA","#96BBAA","#BB6969","#96BBAA","#96AA69","#96BBAA","#96BBAA"]
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.drawbasewindow()
		self.bind("<Button-1>",self.On)
		self.pack(side=LEFT)
		self.bind("<Enter>",self.CursorOn)

	def CursorOn(self=None,event=None):
		self.configure(cursor="hand2")
	def drawbasewindow(self):
		for i in range(self.space):
			color = RGB2STR(self.colorTable[i])
			self.create_line(i,i,self.wx-i,i,fill=color)
			self.create_line(i,self.hy-i,self.wx-i,self.hy-i,fill=color)
			self.create_line(i,i,i,self.hy-i,fill=color)
			self.create_line(self.wx-i,i,self.wx-i,self.hy+1-i,fill=color)
		color = "#%02X%02X%02X" % (self.bc[0],self.bc[1],self.bc[2])
		self.bt[0]=self.create_rectangle((self.space),(self.space),(self.wx-self.space),(self.hy-self.space),fill=color)
		self.bt[1]=self.create_polygon(self.polyOff[self.ctrlsId],fill=self.colorOff[self.ctrlsId])

	def On(self=None,event=None):
		if self.push != 1:
			self.push = 1
			for i in range(2):
				self.delete(self.bt[i])
			color = "#454545"
			self.bt[0]=self.create_rectangle((self.space+2),(self.space+2),(self.wx-self.space-2),(self.hy-self.space-2),fill=color)
			self.bt[1]=self.create_polygon(self.polyOn[self.ctrlsId],fill=self.colorOn[self.ctrlsId])
			if self.command != None:
				self.command(event)
			if self.spring == 1:
				self.after(500,self.Off)
			if self.spring == 3:
				self.bind("<Button-1>",self.Off)
	def Off(self=None,event=None):
		if (self.spring != 3) | ((self.spring == 3)&(event!=None)):
			self.push = 0
			for i in range(2):
				self.delete(self.bt[i])
			color = "#%02X%02X%02X" % (self.bc[0],self.bc[1],self.bc[2])
			self.bt[0]=self.create_rectangle((self.space),(self.space),(self.wx-self.space),(self.hy-self.space),fill=color)
			self.bt[1]=self.create_polygon(self.polyOff[self.ctrlsId],fill=self.colorOff[self.ctrlsId])
			if (self.command != None) & (self.comx2!=0):
				self.command(event)
			if self.spring == 3:
				self.bind("<Button-1>",self.On)

	def state(self=None,event=None):
		return self.push

if __name__=="__main__":
	from CLASS_BOX_ELEMENTS import *
	root=Tk()
	root.title("CLASS_MENU_BUTTON")
	frame = Frame(root,bg="#000000",border=2,relief=FLAT)
	rgb = [255,200,100]
	front=FRONTBOX(frame,width=160,rgb=rgb)
	capleft = CAPBOX(front,side="LEFT",rgb=rgb)
	start = CTRL_BUTTON(front,rgb=rgb,ctrls="START")
	rew = CTRL_BUTTON(front,rgb=rgb,ctrls="REW")
	play = CTRL_BUTTON(front,rgb=rgb,ctrls="PLAY")
	rec = CTRL_BUTTON(front,rgb=rgb,ctrls="REC")
	stop = CTRL_BUTTON(front,rgb=rgb,ctrls="STOP")
	pause = CTRL_BUTTON(front,rgb=rgb,ctrls="PAUSE")
	ff = CTRL_BUTTON(front,rgb=rgb,ctrls="FF")
	end = CTRL_BUTTON(front,rgb=rgb,ctrls="END")
	capright = CAPBOX(front,side="RIGHT",rgb=rgb)
	frame.pack(side=TOP)
	root.mainloop()
