#!/usr/bin/python

########  EMI_ELEMENTS_4_BOX_CREATION  ###########
#                  FLB STUDIO 2K4 (c) 2003-2004                       #
##############################################
#            RESONANT LOWPASS FILTER EMI EFC BOX             #
##############################################

from Tkinter import *
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_FX_BOX_MENU import *
from CLASS_NUMERIC_LED import *

class EFC(Frame):
	def __init__(self,master=None,ID=0,EMICOM=None,ECATALK=None,parentID=None,CHAINCOM=None):
		self.EMICOM=EMICOM
		self.CHAINCOM=CHAINCOM
		self.ECATALK = ECATALK
		self.ID = ID
		self.parentID = parentID
		self.action = 0
		self.master = master
		self.rgb = [50,75,100]
		self.hy = 50
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.indexled = None
		self.rsmled = None
		self.fbkled = None
		self.wetled = None
		self.rsmV=50
		self.fbkV=50
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000",width=800)
		self.front = FRONTBOX(self,rgb=self.rgb,width=1024)
		self.lscrew = SCREWS(self.front,side="LEFT")
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb)
		self.label1 = Label(self.front,text="EFC",bg=self.color,fg=(RGB2STR(RGBGETHIGHLIGHT(self.rgb))),width=6).pack(side=LEFT)
		self.fxMenu = FX_BOX_MENU(EMICOM=self.EMICOM,CHAINCOM=self.CHAINCOM,ECATALK=self.ECATALK,bkcolor=self.color,ID=self.ID,parentID=self.parentID,command=self.rembox)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.fxMenu.popup,txt="C")
		self.indexled= NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ID")
		self.indexled.pack(side=LEFT)
		self.spacer0 = FRONTBOX(self.front,rgb=self.rgb,width=10)
		self.rsmled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="DLS",editable=1,command=self.SetRSM,maximum=100,roller=1,rollercolorcap="#FF00DD",isFloat=2)
		self.rsmled.pack(side=LEFT)
		self.fbkled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="RAD",editable=1,command=self.SetFBK,maximum=100,roller=1,rollercolorcap="#FFEE00",isFloat=2)
		self.fbkled.pack(side=LEFT)
		self.spacer1 = BOX_SPACER(self.front,rgb=self.rgb,wx=320)
		self.rscrew = SCREWS(self.front,side="RIGHT")
		self.capright = CAPBOX(self.front,side="RIGHT",rgb=self.rgb)
		self.pack(side=TOP,fill=X)
		self.SetID(self.ID)
		self.rsmled.simpleSet(self.rsmV)
		self.fbkled.simpleSet(self.fbkV)
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command(("c-select " + cn))
		self.ECATALK.command("cop-add -efc:0.5,0.5")
		self.EMICOM[21](("COP EFC (RESONANT ALLPASS FILTER) IS ADD TO CHAIN "+cn+" AT INDEX "+str(self.ID)))
	def rembox(self=None,event=None):
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("cop-remove")
		self.EMICOM[21](("COP EFC (RESONANT ALLPASS FILTER) IS REMOVE FROM CHAIN "+cn+" AT INDEX "+str(self.ID)))
		self.CHAINCOM[1](self.ID)
	def SetParentID(self=None,event=None):
		self.parentID = event
		self.fxMenu.SetParentID(self.parentID)
	def SetID(self=None,event=None):
		self.ID = event
		self.fxMenu.SetID(self.ID)
		self.indexled.Set(self.ID)

	def GetID(self=None,event=None):
		return self.ID

	def SetRSM(self=None,event=None):
		print self.ID
		self.rsmV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 1")
		self.ECATALK.command(("copp-set "+str(float(event)/100)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -efa AT INDEX "+str(self.ID)+"\nCOPP DELAY SAMPLE AT INDEX 1\nSET TO "+str(float(event)/100)))
	def SetFBK(self=None,event=None):
		self.fbkV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 2")
		self.ECATALK.command(("copp-set "+str(float(event)/100)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -efa AT INDEX "+str(self.ID)+"\nCOPP FEEDBACK AT INDEX 2\nSET TO "+str(float(event)/100)))
	def GetRSM(self=None,event=None):
		return self.rsmV
	def GetFBK(self=None,event=None):
		return self.fbkV
if __name__=="__main__":

	root=Tk()
	root.title("CLASS_EFA")
	root.configure(bg="#000000")
	ete = EFC(root)

	root.mainloop()
