#!/usr/bin/python

######## EMI_ELEMENTS_4_BOX_CREATION ########
#              FLB STUDIO 2K4 (c) 2003-2004 #
#############################################
#                       CHORUS EMI ENM BOX  #
#############################################

from Tkinter import *
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_FX_BOX_MENU import *
from CLASS_NUMERIC_LED import *

class ENM(Frame):
	def __init__(self,master=None,ID=0,EMICOM=None,ECATALK=None,parentID=None,CHAINCOM=None):
		self.EMICOM=EMICOM
		self.CHAINCOM=CHAINCOM
		self.ECATALK = ECATALK
		self.ID = ID
		self.parentID = parentID
		self.action = 0
		self.master = master
		self.rgb = [175,150,0]
		self.hy = 50
		self.color = RGB2STR(self.rgb)
		self.indexled = None
		self.dtmled = None
		self.vtsled = None
		self.fbkled = None
		self.lfoled = None
		self.dtmV=10
		self.modV=100
		self.ndrV=100
		self.mixV=100
		self.fbkV=100
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000",width=800)
		self.front = FRONTBOX(self,rgb=self.rgb,width=1024)
		self.lscrew = SCREWS(self.front,side="LEFT")
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb)
		self.label1 = Label(self.front,text="ENM",bg=self.color,fg=(RGB2STR(RGBGETHIGHLIGHT(self.rgb))),width=6).pack(side=LEFT)
		self.fxMenu = FX_BOX_MENU(EMICOM=self.EMICOM,CHAINCOM=self.CHAINCOM,ECATALK=self.ECATALK,bkcolor=self.color,ID=self.ID,parentID=self.parentID,command=self.rembox)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.fxMenu.popup,txt="C")
		self.indexled= NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ID")
		self.indexled.pack(side=LEFT)
		self.spacer0 = FRONTBOX(self.front,rgb=self.rgb,width=10)
		self.dtmled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=2,title="LEV",editable=1,command=self.SetDTM,maximum=99,roller=1,rollercolorcap="#FFEE00")
		self.dtmled.pack(side=LEFT)
		self.modled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="PRE",editable=1,command=self.SetMOD,maximum=999,isFloat=3)
		self.modled.pack(side=LEFT)
		self.ndrled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ATT",editable=1,command=self.SetNDR,maximum=999,isFloat=3)
		self.ndrled.pack(side=LEFT)
		self.mixled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="POS",editable=1,command=self.SetMIX,maximum=999,isFloat=3)
		self.mixled.pack(side=LEFT)
		self.fbkled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="REL",editable=1,command=self.SetFBK,maximum=999,isFloat=3)
		self.fbkled.pack(side=LEFT)
		self.spacer1 = BOX_SPACER(self.front,rgb=self.rgb,wx=30)
		self.rscrew = SCREWS(self.front,side="RIGHT")
		self.capright = CAPBOX(self.front,side="RIGHT",rgb=self.rgb)
		self.pack(side=TOP,fill=X)
		self.SetID(self.ID)
		self.dtmled.simpleSet(self.dtmV)
		self.modled.simpleSet(self.modV)
		self.ndrled.simpleSet(self.ndrV)
		self.mixled.simpleSet(self.mixV)
		self.fbkled.simpleSet(self.fbkV)
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command(("c-select " + cn))
		self.ECATALK.command(("cop-add -enm:+"+str(self.dtmV)+","+str(self.modV)+","+str(self.ndrV)+","+str(self.mixV)+","+str(self.fbkV)))
		self.EMICOM[21](("COP ENM (NOISE GATE) IS ADD TO CHAIN "+cn+" AT INDEX "+str(self.ID)))
	def rembox(self=None,event=None):
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("cop-remove")
		self.EMICOM[21](("COP ENM (NOISE GATE) IS REMOVE FROM CHAIN "+cn+" AT INDEX "+str(self.ID)))
		self.CHAINCOM[1](self.ID)
	def SetParentID(self=None,event=None):
		self.parentID = event
		self.fxMenu.SetParentID(self.parentID)
	def SetID(self=None,event=None):
		self.ID = event
		self.fxMenu.SetID(self.ID)
		self.indexled.Set(self.ID)
	def GetID(self=None,event=None):
		return self.ID
	def SetDTM(self=None,event=None):
		self.dtmV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 1")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etd AT INDEX "+str(self.ID)+"\nCOPP TRESHOLD-LEVEL AT INDEX 1\nSET TO "+str(event)+" %"))
	def SetMOD(self=None,event=None):
		self.modV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 2")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("FROM CHAIN "+str(self.parentID)+" PRE-HOLD-TIME SET TO "+str(event)+"  FOR ENM AT INDEX "+str(self.ID)+" msec"))
	def SetNDR(self=None,event=None):
		self.ndrV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 3")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etd AT INDEX "+str(self.ID)+"\nCOPP ATTACK-TIME AT INDEX 3\nSET TO "+str(event)+" msec"))
	def SetMIX(self=None,event=None):
		self.mixV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 4")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etd AT INDEX "+str(self.ID)+"\nCOPP POST-HOLD AT INDEX 4\nSET TO "+str(event)+" msec"))
	def SetFBK(self=None,event=None):
		self.fbkV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 5")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etd AT INDEX "+str(self.ID)+"\nCOPP RELEASE-TIME AT INDEX 5\nSET TO "+str(event)+" msec"))
	def GetDTM(self=None,event=None):
		return self.dtmV
	def GetMOD(self=None,event=None):
		return self.modV
	def GetNDR(self=None,event=None):
		return self.ndrV
	def GetMIX(self=None,event=None):
		return self.mixV
	def GetFBK(self=None,event=None):
		return self.fbkV



if __name__=="__main__":

	root=Tk()
	root.title("CLASS_ENM")
	root.configure(bg="#000000")
	ete = ETE(root)

	root.mainloop()
