#!/usr/bin/python

############ EMI_TRANSPORT_TIMER ################
#                    FLB STUDIO 2K3 (c) 2003-2004                       #
###############################################
#          TKINTER GRAPHICS CLASS OBJECTS LIBRARY              #
###############################################

from Tkinter import *
from COLOR_FADER import *
import sys
from CLASS_BOX_ELEMENTS import ROLL_BUTTON


class NUMERIC_LED(Canvas):
	def __init__(self,master=None,rgb=None,v=10,command=None,ID=None,ledcolor="blue",abort=None):
		self.master=master
		self.wx = 22
		self.hy = 27
		self.v = v
		self.extV=0
		self.rgbBOX = rgb
		self.space=10
		self.lastfocus=None
		self.command=command
		self.ID=ID
		self.blinking=0
		self.color = "#%02X%02X%02X" % (self.rgbBOX[0],self.rgbBOX[1],self.rgbBOX[2])
		self.colorTable=RGB2RGB(rgb,[0,0,0],self.space)
		self.ledcolor=None
		if ledcolor=="pink":
			self.ledcolor=["#752550","#FFAAFF"]
		else:
			self.ledcolor=["#257550","#00FFFF"]
			
		self.rgb =self.ledcolor
		self.abort=abort
		self.rgb0 = [self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1],self.rgb[1]]
		self.rgb1 = [self.rgb[0],self.rgb[0],self.rgb[1],self.rgb[0],self.rgb[0],self.rgb[1],self.rgb[0]]
		self.rgb2 = [self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1]]
		self.rgb3 = [self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1]]
		self.rgb4 = [self.rgb[0],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[0]]
		self.rgb5 = [self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1]]
		self.rgb6 = [self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1]]
		self.rgb7 = [self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[0],self.rgb[0],self.rgb[1],self.rgb[0]]
		self.rgb8 = [self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1]]
		self.rgb9 = [self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[1],self.rgb[0],self.rgb[1],self.rgb[1]]
		self.rgbOff = [self.rgb[0],self.rgb[0],self.rgb[0],self.rgb[0],self.rgb[0],self.rgb[0],self.rgb[0]]
		self.rgbs = [self.rgb0,self.rgb1,self.rgb2,self.rgb3,self.rgb4,self.rgb5,self.rgb6,self.rgb7,self.rgb8,self.rgb9,self.rgbOff]
		self.geometrys = [(9,8, 10,7, 13,7, 13,8, 12,9, 10,9),(8,9, 9,10, 9,12, 8,13, 7,12, 7,10),(14,9, 15,10, 16,9, 16,13, 14,12),(9,14, 10,13, 12,14, 14,14, 12,15, 10,15),(8,15, 9,16, 9,18, 8,18, 7,18, 7,16),(14,15, 15,16, 15,18, 14,19, 13,18, 13,16),(9,20, 10,19, 12,19, 13,20, 12,21, 10,21)]
		self.led = [0]*7
		Canvas .__init__(self,master=self.master,width=self.wx,height=self.hy+3,bg=self.color,border=0,bd=0,highlightthickness=0,highlightbackground=self.color)
		self.drawbasewindow()
		self.draw()

	def drawbasewindow(self=None,event=None):
		for i in range(self.space):
			color = RGB2STR(self.colorTable[i])
			self.create_line(i,i,self.wx-i,i,fill=color)
			self.create_line(i,self.hy-i,self.wx-i,self.hy-i,fill=color)
			self.create_line(i,i,i,self.hy-i,fill=color)
			self.create_line(self.wx-i,i,self.wx-i,self.hy+1-i,fill=color)
		self.create_rectangle(5,5,self.wx-5,self.hy-5,fill="#002550")

	def focusme(self=None,event=None):
		self.lastfocus=self.focus_get()
		self.focus_set()
		self.bind("<Key>",self.readkey)
		self.lastV=self.v
		self.blinking=1
		self.blink()

	def readkey(self=None,event=None):
		a=event.keysym
		if a =="KP_Insert":
			a="0"
		if a =="KP_End":
			a="1"
		if a =="KP_Down":
			a="2"
		if a =="KP_Next":
			a="3"
		if a =="KP_Left":
			a="4"
		if a =="KP_Begin":
			a="5"
		if a =="KP_Right":
			a="6"
		if a =="KP_Home":
			a="7"
		if a =="KP_Up":
			a="8"
		if a =="KP_Prior":
			a="9"
		if a =="Escape":
			self.abort(a)
			self.blinking=0
			self.lastfocus.focus_set()
		if a =="Return":
			self.abort(a)
			self.blinking=0
			self.lastfocus.focus_set()
		else:
			for i in range(10):
				if a == str(i):
					self.extV=i
					if self.extV!=None:
						self.blinking=0
						self.Set(self.extV)
						self.lastfocus.focus_set()
						if self.command!=None:
							self.command(self.ID+1)

	def blink(self=None,event=None):
		if self.blinking==1:
			if self.v == self.lastV:
				self.Set(10)
			else:
				self.Set(self.lastV)
			self.after(100,self.blink)
	def Set(self=None,event=None):
		self.v=event
		self.flush()
		self.draw()

	def Get(self=None,event=None):
		return self.v

	def draw(self=None,event=None):
		for i in range(len(self.led)):
			self.led[i]=self.create_polygon(self.geometrys[i],fill=self.rgbs[self.v][i])
	def flush(self=None,event=None):
		for i in range(len(self.led)):
			self.delete(self.led[i])

class NUMERIC_LED_SET(Canvas):
	def __init__(self,master=None,rgb=None,v=0,Qut=0,title="",editable=0,minimum=0,maximum=999,NumFloat=0,command=None,roller=None,rollercolorcap="#55FFAA",isFloat=0):
		self.master=master
		self.editable=editable
		self.rgb=rgb
		self.v=v
		self.lastV=0
		self.Qut=Qut
		self.title="  "+title
		self.ledset = [0]*self.Qut
		self.color = RGB2STR(self.rgb)
		self.blinking=0
		self.blinkon="#FFFFFF"
		self.newstr=""
		self.saisieis=0
		self.minimum=minimum
		self.maximum=maximum
		self.NumFloat=NumFloat
		self.command = command
		self.roller=roller
		self.rollercolorcap=rollercolorcap
		self.r=None
		self.isFloat=isFloat
		self.colortable1=[]
		self.colortable2=[]
		self.colortable3=[]
		self.colortable4=[]
		if self.editable==1:
			self.colortable1=RGB2RGB(self.rgb,RGBGETVERYHIGHLIGHT(self.rgb),30)
			self.colortable2=RGB2RGB(RGBGETVERYHIGHLIGHT(self.rgb),self.rgb,20)
			self.colortable3=RGB2RGB(RGBGETDARKSHADOW(self.rgb),RGBGETVERYHIGHLIGHT(self.rgb),40)
			self.colortable4=RGB2RGB(RGBGETDARKSHADOW(self.rgb),RGBGETVERYHIGHLIGHT(self.rgb),8)
		else:
			self.colortable1=RGB2RGB(self.rgb,RGBGETHIGHLIGHT(self.rgb),30)
			self.colortable2=RGB2RGB(RGBGETLIGHT(self.rgb),self.rgb,20)
			self.colortable3=RGB2RGB(RGBGETVERYDARKSHADOW(self.rgb),RGBGETLIGHT(self.rgb),40)
			self.colortable4=RGB2RGB(RGBGETVERYDARKSHADOW(self.rgb),RGBGETLIGHT(self.rgb),8)
		Canvas .__init__(self,master=self.master,bg=self.color,border=0,bd=0,highlightthickness=0)
		self.canvas=Canvas(self,bg=self.color,border=0,bd=0,highlightthickness=0,width=48,height=34)
		self.canvas.pack(side=LEFT)
		for i in range(40):
			color=RGB2STR(self.colortable3[i])
			self.canvas.create_line(48-i,0,48-i,34,fill=color)
		for i in range(8):
			color=RGB2STR(self.colortable4[i])
			self.canvas.create_line(0+i,0,0+i,35,fill=color)
		self.texte= self.canvas.create_text(24,17,text=self.title,anchor=CENTER,fill=(RGB2STR(RGBGETVERYDARKSHADOW(RGBGETVERYDARKSHADOW(self.rgb)))),font="helvetica 10  bold")
		for i in range(self.Qut):
			if i >= (self.Qut-self.isFloat):
				self.ledset[i]= NUMERIC_LED(self,rgb=self.rgb,v=self.v,command=self.saisie,ID=i,abort=self.abort,ledcolor="pink")
				self.ledset[i].pack(side=LEFT)
			else:
				self.ledset[i]= NUMERIC_LED(self,rgb=self.rgb,v=self.v,command=self.saisie,ID=i,abort=self.abort)
				self.ledset[i].pack(side=LEFT)
		if self.roller!=None:
			self.createroll()
		if self.editable!=0:
			self.canvas.bind("<Button-1>",self.SSBL)
			self.canvas.bind("<Enter>",self.CursorOn)

	def CursorOn(self=None,event=None):
		self.canvas.configure(cursor="hand2")
	def createroll(self=None,event=None):
		self.r=ROLL_BUTTON(self,rgb=self.rgb,capcolor=self.rollercolorcap,startV=self.minimum,endV=self.maximum,command=self.simpleSet,BOXCOM=self.Set)
		self.r.pack(side=LEFT)
	def abort(self=None,event=None):
		a=event
		if a =="Return":
			for i in range(self.Qut):
				self.newstr=self.newstr+str(self.ledset[i].Get())
			if int(self.newstr) <= self.maximum:
				self.Set(int(self.newstr))
			else:
				self.saisieoff()
			self.saisieis=0
			self.SSBL()
			self.newstr=""
		else:
			self.saisieoff()
			self.saisieis=0
			self.SSBL()
			self.newstr=""
	def simpleSet(self=None,event=None):
		self.lastV=event
		self.v = event
		a = len(str(event))
		astr = str(event)
		while len(astr) < self.Qut:
			astr="0"+astr
		for i in range(self.Qut):
			self.ledset[i].Set(int(astr[i]))
		if self.r!=None:
			self.r.simpleSet(self.v)
	def Set(self=None,event=None):
		self.lastV=event
		self.v = event
		a = len(str(event))
		astr = str(event)
		while len(astr) < self.Qut:
			astr="0"+astr
		for i in range(self.Qut):
			self.ledset[i].Set(int(astr[i]))
		if self.command!=None:
			self.command(self.v)
		if self.r!=None:
			self.r.simpleSet(self.v)
	def Get(self=None,event=None):
		return self.v

	def SSBL(self=None,event=None):
		if self.blinking==0:
			self.saisieis=1
			self.blinking=1
			self.canvas.delete(self.texte)
			self.texte= self.canvas.create_text(24,17,text=self.title,anchor=CENTER,fill=(RGB2STR(RGBGETVERYHIGHLIGHT(self.rgb))),font="helvetica 10  bold")
			self.saisie()
		elif self.saisieis==0:
			self.blinking=0
			self.canvas.delete(self.texte)
 			self.texte= self.canvas.create_text(24,17,text=self.title,anchor=CENTER,fill=(RGB2STR(RGBGETVERYDARKSHADOW(self.rgb))),font="helvetica 10  bold")


	def saisie(self=None,event=None):
		if event ==None:
			a=0
		else:
			a=event
		if a != len(self.ledset):
			self.ledset[a].focusme()
		else:
			for i in range(self.Qut):
				self.newstr=self.newstr+str(self.ledset[i].Get())
			if int(self.newstr) <= self.maximum:
				self.Set(int(self.newstr))
			else:
				self.saisieoff()
			self.saisieis=0
			self.SSBL()
			self.newstr=""
	def saisieoff(self=None,event=None):
		self.simpleSet(self.lastV)
		self.SSBL()

if __name__=="__main__":

	root=Tk()
	root.title("CLASS_LEDS")
	led = NUMERIC_LED(root,rgb=[69,69,69])
	led.pack(side=LEFT)
	a = 0
	def inc():
		global a
		if a < 10:
			a = a + 1
			led.Set(a)

		else:
			a = 0
			led.Set(a)
		print a

	incbut = Button(root,text="increment",command=inc)
	incbut.pack(side=LEFT)
	root.mainloop()
