#!/usr/bin/python

########  EMI_ELEMENTS_4_BOX_CREATION  ###########
#                  FLB STUDIO 2K4 (c) 2003-2004                     #
#############################################
#                        STANDARD EMI BOX                                 #
#############################################

from Tkinter import *
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_FX_BOX_MENU import *
from CLASS_NUMERIC_LED import *
from COLOR_FADER import *

class STANDARD_BOX(Frame):
	def __init__(self,master=None,ID=None,parentID=None,EMICOM=None,CHAINCOM=None,ECATALK=None,Name=None,COPName=None,rgb=[200,0,0],initV=None,PName=None,PDef=None,PWidth=None,LedQut=None,isRoll=None,isFloat=None,editable=None,CapColor=None,spacerWx=50,isGrille=0):
		self.EMICOM=EMICOM
		self.CHAINCOM=CHAINCOM
		self.ECATALK = ECATALK
		self.ID = ID
		self.Name=Name
		self.COPName=COPName
		self.PName=PName
		self.PDef=PDef
		self.PWidth=PWidth
		self.LedQut=LedQut
		self.isRoll=isRoll
		self.isFloat=isFloat
		self.editable = editable
		self.spacerWx=spacerWx
		self.isGrille=isGrille
		self.CapColor=CapColor
		self.parentID = parentID
		self.master = master
		self.rgb = rgb
		self.hy = 50
		self.pn=0 #len(initV)
		self.color = RGB2STR(self.rgb)
		self.pv=initV
		self.ledset=[0]*self.pn
		self.commander=[self.setPA,self.setPB,self.setPC,self.setPD,self.setPE,self.setPF,self.setPG]
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000",width=800)
		self.front = FRONTBOX(self,rgb=self.rgb,width=1024)
		self.lscrew = SCREWS(self.front,side="LEFT")
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb)
		self.label1 = Label(self.front,text="EA",bg=self.color,fg=(RGB2STR(RGBGETHIGHLIGHT(self.rgb))),width=6).pack(side=LEFT)
		self.fxMenu = FX_BOX_MENU(EMICOM=self.EMICOM,CHAINCOM=self.CHAINCOM,ECATALK=self.ECATALK,bkcolor=self.color,ID=self.ID,parentID=self.parentID,command=self.rembox)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.fxMenu.popup,txt="C")
		self.indexled= NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ID")
		self.indexled.pack(side=LEFT)
		self.spacer0 = FRONTBOX(self.front,rgb=self.rgb,width=10)
		for i in range(self.pn):
			self.ledset[i]=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=self.initV[i],Qut=self.LedQut[i],title=self.PName[i],editable=self.editable[i],command=self.commander[i],maximum=self.Pwidth[i][1],roller=self.isRoller,rollercolorcap=self.CapColor[i])
			self.ledset[i].pack(side=LEFT)
		self.spacer1 = BOX_SPACER(self.front,rgb=self.rgb,wx=self.spacerWx,grille=self.isGrille)
		self.rscrew = SCREWS(self.front,side="RIGHT")
		self.capright = CAPBOX(self.front,side="RIGHT",rgb=self.rgb)
		self.pack(side=TOP,fill=X)
		self.SetID(self.ID)
		for i in range(self.pn):
			self.parameter_ledset[i].simpleSet(self.parameter_value[i])
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command(("c-select " + cn))
		self.ecaInit()
	def ecaInit(self=None,event=None):
		s=","
		com_str="cop-add "+self.PARAMETER_LIST[0][1]
		for i in range(self.pn):
			if i != (self.pn-1):
				com_str = com_str+str(self.PARAMETER_LIST[2][1][i])+s
			else:
				com_str = com_str+str(self.PARAMETER_LIST[2][1][i])
		self.ECASTALK.command(com_str)
		self.EMICOM[21](("COP "+self.PARAMETER_LIST[0][0]+" IS ADD TO CHAIN "+cn+" AT INDEX "+str(self.ID)))

	def rembox(self=None,event=None):
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("cop-remove")
		self.EMICOM[21](("COP "+self.PARAMETER_LIST[0][0]+" IS REMOVE FROM CHAIN "+cn+" AT INDEX "+str(self.ID)))
		self.CHAINCOM[1](self.ID)
	def SetParentID(self=None,event=None):
		self.parentID = event
		self.fxMenu.SetParentID(self.parentID)
	def SetID(self=None,event=None):
		self.ID = event
		self.fxMenu.SetID(self.ID)
		self.indexled.Set(self.ID)
	def GetID(self=None,event=None):
		return self.ID
	def setPA(self=None,event=None):
		self.parameter_value[0]=event
		self.SetPara(0)
	def setPB(self=None,event=None):
		self.parameter_value[1]=event
		self.SetPara(1)
	def setPC(self=None,event=None):
		self.parameter_value[2]=event
		self.SetPara(2)
	def setPD(self=None,event=None):
		self.parameter_value[3]=event
		self.SetPara(3)
	def setPE(self=None,event=None):
		self.parameter_value[4]=event
		self.SetPara(4)
	def setPF(self=None,event=None):
		self.parameter_value[5]=event
		self.SetPara(5)
	def setPG(self=None,event=None):
		self.parameter_value[6]=event
		self.SetPara(6)
	def SetPara(self=None,event=None):
		f =self.PARAMETER_LIST[9][1][event]
		x=0
		for i in range(f):
			if i==0:
				x=10
			else:
				x=x*10
		v=float(self.parameter_value[event])/x
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select "+str(event))
		self.ECATALK.command(("copp-set "+str(v) ))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\n "+self.PARAMETER_LIST[0][0]+" AT INDEX "+str(self.ID)+"\nCOPP AT INDEX "+str(event)+"\nSET TO "+str(self.parameter_value[event]) ))

	def GetPara(self=None,event=None):
		return self.parameter_value[event]



if __name__=="__main__":

	root=Tk()
	root.title("CLASS_STANDARD_BOX")
	root.configure(bg="#000000")
	ete = STANDARD_BOX(root)

	root.mainloop()
