#!/usr/bin/python

########EMI_ELEMENTS_4_BOX_CREATION ###########
#       FLB STUDIO 2K4 (c) 2003-2004          #
###############################################
#              POP-MENU BUTTON                #
###############################################

from Tkinter import *
from COLOR_FADER import *

class TOGGLE_BUTTON(Canvas):
	def __init__(self,master=None,rgb=[90,90,255],command=None,txt="B",txton=None,textColor=["#000000","#FFFFFF"],bc=[204,80,0]):
		self.master = master
		self.hy = 30
		self.wx = 30
		self.rgb = rgb
		self.space = 5
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.colorTable=RGB2RGB(self.rgb,[40,40,40],self.space)
		self.divider = int(self.hy/self.space/2)
		self.txt=txt
		self.txton=txton
		self.texte=txt
		self.textColor = textColor
		self.command=command
		self.bc = bc
		self.bt = [0]*2
		self.toggleOn=0
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.drawbasewindow()
		self.bind("<Button-1>",self.toggle)
		self.pack(side=LEFT)
		self.bind("<Enter>",self.CursorOn)
	def CursorOn(self=None,event=None):
		self.configure(cursor="hand2")
	def drawbasewindow(self):
		for i in range(self.space):
			color = RGB2STR(self.colorTable[i])
			self.create_line(i,i,self.wx-i,i,fill=color)
			self.create_line(i,self.hy-i,self.wx-i,self.hy-i,fill=color)
			self.create_line(i,i,i,self.hy-i,fill=color)
			self.create_line(self.wx-i,i,self.wx-i,self.hy+1-i,fill=color)
		color = "#%02X%02X%02X" % (self.bc[0],self.bc[1],self.bc[2])
		self.bt[0]=self.create_rectangle((self.space),(self.space),(self.wx-self.space),(self.hy-self.space),fill=color)
		self.bt[1]=self.create_text(15,16,text=self.txt,anchor=CENTER,fill=self.textColor[0],font="helvetica 12  bold")
	def toggle(self=None,event=None):
		if self.toggleOn==0:
			self.On()
		else:
			self.toggleOn=0
			self.Off()
		if self.command!=None:
			self.command()
	def On(self=None,event=None):
		self.toggleOn=1
		if self.txton!=None:
			self.texte=self.txton
		for i in range(2):
			self.delete(self.bt[i])
		color = "#%02X%02X%02X" % (self.bc[0],self.bc[1],self.bc[2])
		self.bt[0]=self.create_rectangle((self.space+2),(self.space+2),(self.wx-self.space-2),(self.hy-self.space-2),fill=color)
		self.bt[1]=self.create_text(15,16,text=self.texte,anchor=CENTER,fill=self.textColor[1],font="helvetica 8  bold")
	def Off(self=None,event=None):
		self.toggleOn=0
		self.texte=self.txt
		for i in range(2):
			self.delete(self.bt[i])
		color = "#%02X%02X%02X" % (self.bc[0],self.bc[1],self.bc[2])
		self.bt[0]=self.create_rectangle((self.space),(self.space),(self.wx-self.space),(self.hy-self.space),fill=color)
		self.bt[1]=self.create_text(15,16,text=self.texte,anchor=CENTER,fill=self.textColor[0],font="helvetica 12  bold")



if __name__=="__main__":
	from CLASS_BOX_ELEMENTS import *
	root=Tk()
	root.title("CLASS_MENU_BUTTON")
	frame = Frame(root,bg="#000000",border=2,relief=FLAT)
	rgb = [255,200,100]
	front=FRONTBOX(frame,rgb=rgb)
	capleft = CAPBOX(front,side="LEFT",rgb=rgb)
	menuButton = TOGGLE_BUTTON(front,rgb=rgb,textColor=["#00AABB","#00BBFF"],bc=[50,50,150])
	capright = CAPBOX(front,side="RIGHT",rgb=rgb)
	frame.pack(side=TOP)
	root.mainloop()
