#!/usr/bin/python

############## EMI_TRANSPORT_BOX ##############
#                     FLB STUDIO 2K3 (c) 2003 #
###############################################
#            TRANSPORT CLASS OBJECTS LIBRARY  #
###############################################

from Tkinter import *
from math import *
import sys
import time
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_MAIN_MENU import *
from CLASS_CTRL_BUTTON import *
from CLASS_CHAIN_TRACKER import *
from CLASS_ETE import *
from CLASS_NUMERIC_LED import *
from tkMessageBox import *
from COLOR_FADER import *

class TRANSPORT(Frame):
	def __init__(self,master=None,EMICOM=None,ECATALK=None):
		self.action = 0
		self.master = master
		self.rgb = [150,0,0]
		self.hy = 50
		self.color = RGB2STR(self.rgb)
		self.lapse = 500
		self.sec = 0.0
		self.startlimit = 0
		self.endlimit = 9999999
		self.EMICOM=EMICOM
		self.ECATALK = ECATALK
		self.f=0.0
		self.ecaRun = 0
		self.TimerTime=0
		self.looping=0
		self.cslength=0.0
		self.cslengthset=0.0
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.front=FRONTBOX(self,rgb=self.rgb,width=1024)
		self.lscrew = SCREWS(self.front,side="LEFT")
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb)
		self.label1 = Label(self.front,text="CS",bg=self.color,fg="#000000",width=6).pack(side=LEFT)
		self.MMenu = MAIN_MENU(EMICOM=self.EMICOM,ECATALK=self.ECATALK,bkcolor=self.color)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.MMenu.popup,txt="C")
		self.spacer1=Frame(self.front,bg=self.color,border=0,width=33,borderwidth=0,highlightcolor=self.color).pack(side=LEFT)
		self.timer = NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=7,title="TMS",maximum=9999999,editable=1,command=self.SetPos,isFloat=3)
		self.timer.pack(side=LEFT)
		self.timeEnd = NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=7,title="END",maximum=9999999,editable=1,command=self.SetLen,isFloat=3)
		self.timeEnd.pack(side=LEFT)
		self.tl = NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=1,title="TL",maximum=1,editable=1,command=self.Loop)
		self.tl.pack(side=LEFT)
		self.spacer0=Frame(self.front,bg=self.color,border=0,width=45,borderwidth=0,highlightcolor=self.color).pack(side=LEFT)
		self.start = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="START",command=self.Start,spring=1)
		self.rew = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="REW",command=self.Rew)
		self.play = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="PLAY",command=self.Play)
		self.stop = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="STOP",command=self.Stop,spring=1)
		self.ff = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="FF",command=self.Ff)
		self.end = CTRL_BUTTON(self.front,rgb=self.rgb,ctrls="END",command=self.End,spring=1)
		self.rscrew = SCREWS(self.front,side="RIGHT")
		self.capright = CAPBOX(self.front,side="RIGHT",rgb=self.rgb)
		self.pack(side=TOP,fill=X)
		self.ctrlsTable=[self.start,self.rew,self.play,self.ff,self.end]
		self.GetTimerTime

	def SetLength(self=None,event=None):
		if event ==0:
			self.ECATALK.command(("cs-set-length -1" ))
		else:
			self.cslengthset=float(event)/1000
			self.ECATALK.command(("cs-set-length "+str(self.cslengthset)))

	def SetEnd(self=None,event=None):
		if event!=None:
			self.cslength=event
		self.timeEnd.simpleSet(int(self.cslength*1000))

	def SetStart(self=None,event=None):
		if event!=None:
			self.cslength=event
		self.timer.simpleSet(int(self.cslength*1000))

	def Start(self=None,event=None):
		self.ECATALK.command("cs-is-valid")
		i=self.ECATALK.last_integer()
		if (self.action == 0) & (i!=0):
			self.Stop()
			self.timer.simpleSet(self.startlimit)
			self.ECATALK.command(("cs-set-position 0.0"))
			self.ECATALK.command("cs-get-position")
			nf=self.ECATALK.last_float()
			self.EMICOM[30]()
		else:
   			self.end.Off()
	def rollRew(self=None,event=None):
		if (self.action == 1)&(self.sec>0.0):
			self.sec=self.sec-1.0
			self.timer.simpleSet((int(self.sec*1000)))
			self.ECATALK.command(("cs-set-position "+str(self.sec)))
			self.after(100,self.rollRew)
		else:
			self.action=0
			self.rew.Off()
	def Rew(self=None,event=None):
		if (self.action == 0)&(self.sec>0.0):
			i=int(self.sec)
			self.sec=float(i)
			self.action=1
			self.rollRew()
		else:
			self.rew.Off()
	def SetPos(self=None,event=None):
		self.ECATALK.command("cs-is-valid")
		si=self.ECATALK.last_integer()
		if  si == 1:
			self.sec = float(event/1000)
			self.ECATALK.command(("cs-set-position "+str(self.sec)))
		elif si ==0:
			self.EMICOM[21]("Chain Is Not Valid!")
			self.timer.simpleSet((int(self.sec*1000)))

	def SetLen(self=None,event=None):
		if event == 0:
			self.EMICOM[21]('Precise cs-length off')
			self.ECATALK.command("cs-set-length -1")
		else:
			self.ECATALK.command("cs-set-length "+str(float(event)/1000))
		
		
	def Play(self=None,event=None):
		self.ECATALK.command("cs-is-valid")
		si=self.ECATALK.last_integer()
		if (self.action == 0) & (si == 1):
			self.sec = 1000
			self.lapse = 1000
			self.action = 1
			self.startlimit = -1
			self.endlimit = 9999999
			self.ECATALK.command("cs-connect")
			self.EMICOM[21]("ECASOUND ENGINE START")
			self.ECATALK.command("start")
			s=self.ECATALK.last_error()
			if s =="":
				self.EcaEngineStatus()
			else:
				self.Stop()
				self.EMICOM[21](("ECASOUND ERROR! \n"+s))
				self.EMICOM[21](("ECASOUND IS FREEZING! \n EMI WILL TRY TO KILL ECASOUND THAN EXIT"))
				self.ECATALK.command("q")
				self.EMICOM[17]()
		elif si ==0:
			self.EMICOM[21]("CHAIN SETUP IS NOT READY!")
			self.play.Off()

	def Stop(self=None,event=None):
		if self.action == 1:
			self.action = 0
			self.startlimit = 0
			self.endlimit = 9999999
			for i in range(len(self.ctrlsTable)):
				self.ctrlsTable[i].Off()
			self.ECATALK.command("stop")
			self.ECATALK.command("get-position")
			self.sec=self.ECATALK.last_float()
			self.timer.simpleSet((int(self.sec*1000)))
			self.ECATALK.command("cs-disconnect")
			self.EMICOM[21]("ECASOUND ENGINE STOP")
	def Loop(self=None,event=None):
		self.ECATALK.command("engine-status")
		s =self.ECATALK.last_string()
		if (event !=self.looping) & (s!="running"):
			self.looping=event
			self.ECATALK.command("cs-toggle-loop")
			if self.looping==0:
				self.EMICOM[21]("TOGGLE LOOPPING SET FALSE!")
				self.ECATALK.command("cs-set-length -1")
			if self.looping==1:
				self.EMICOM[21]("TOGGLE LOOPPING SET TRUE!")
		elif (event !=self.looping) & (s=="running"):
		 	self.tl.Set((self.looping))
			self.EMICOM[21]("ECASOUND ENGINE  RUNNING! CANNOT TOGGLE LOOPPING!")
	def rollFf(self=None,event=None):
		if (self.action == 1)&(self.sec<self.f):
			self.sec=self.sec+1.0
			self.timer.simpleSet((int(self.sec*1000)))
			self.ECATALK.command(("cs-set-position "+str(self.sec)))
			self.after(100,self.rollFf)
		else:
			self.action=0
			self.sec=self.f
			self.timer.simpleSet((int(self.sec*1000)))
			self.ECATALK.command(("cs-set-position "+str(self.sec)))
			self.ff.Off()
	def Ff(self=None,event=None):
		self.ECATALK.command("cs-get-length")
		self.f=self.ECATALK.last_float()
		if (self.action == 0)&(self.sec<self.f):
			i=int(self.sec)
			self.sec=float(i)
			self.action=1
			self.rollFf()
		else:
			self.ff.Off()
	def End(self=None,event=None):
		if self.action == 0:
			self.ECATALK.command("cs-get-length")
			f=self.ECATALK.last_float()
			self.sec=f
			self.SetEnd(f)
			self.ECATALK.command(("cs-set-position "+ str(f) ))
			self.timer.Set((int(f*1000)))
			self.EMICOM[21](("ECASOUND ENGINE SET TO POSTION:"+str(f)))
		else:
			self.end.Off()
	def GetTimerTime(self=None,event=None):
		self.TimerTime=int(self.timer.Get())

	def EcaEngineStatus(self=None,event=None):
		s=self.ECATALK.last_error()
		if s!="":
			self.EMICOM[21]("ECASOUND ENGINE DROP OUT! \n"+s)
			self.Stop()
		if self.action == 1:
			self.ECATALK.command("engine-status")
			s =self.ECATALK.last_string()
			if  s == "stopped":
				self.after(self.lapse,self.EcaEngineStatus)
			elif s == "finished":
				self.Stop()
			elif s == "running":
				self.ECATALK.command("get-position")
				self.sec=self.ECATALK.last_float()
				self.timer.simpleSet((int(self.sec*1000)))
				self.after(10,self.EcaEngineStatus)
		else:
			self.ECATALK.command("engine-status")
			s =self.ECATALK.last_string()
			if  s != "stopped":		
				self.Stop()


if __name__=="__main__":

	root=Tk()
	root.title("CLASS_TRANSPORT")
	root.configure(bg="#000000")
	transport = TRANSPORT(root)

	root.mainloop()
